<template>
  <v-text-field
    :rules="label ? [validate] : []"
    :label="placeholder"
    :disabled="label === null"
    :value="field"
    @input="onInput"
    @keydown.exact.up="increment(1)"
    @keydown.exact.down="increment(-1)"
    @keydown.shift.up="increment(1, true)"
    @keydown.shift.down="increment(-1, true)"
  />
</template>
<script lang="ts">
import { Component, Prop } from 'vue-property-decorator';
import type { Label, LabelOnsetKey, Signature } from '@/data';
import type VueI18n from 'vue-i18n';
import LabelField from './LabelField.vue';

/**
 * Base class for musical time editing field
 *
 * Sets LabelField props as well as:
 * * signature: the time signature of the piece
 *
 * Sets rendering and increment/decrement events
 *
 * The class is a template to allow for type safety of the conversion functions
 *
 * To use, extend the class, and define the following members
 * * parse: return new values from string input
 * * print: display current value into the field
 * * key: the key of the label property to modify
 */
@Component
export default class MusicalTimeField<K extends LabelOnsetKey> extends LabelField<K> {
  @Prop({ required: true })
  signature!: Signature;

  placeholder!: VueI18n.TranslateResult;

  increment(direction: number, isMeasure = false) {
    if (this.label === null || this.lastOk === null) return;

    const increment = isMeasure ? this.signature.measureIncrement : this.signature.increment;

    const newTime = this.lastOk + direction * increment;

    // Simulate input of new calculated value
    this.onInput(this.print(newTime as Label[K]));
  }
}
</script>
